(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('tslib'), require('@angular/core'), require('@angular/common'), require('@angular/elements'), require('@angular/platform-browser'), require('rxjs/observable/fromPromise'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('iwe7-elements', ['exports', 'tslib', '@angular/core', '@angular/common', '@angular/elements', '@angular/platform-browser', 'rxjs/observable/fromPromise', 'rxjs'], factory) :
    (factory((global['iwe7-elements'] = {}),global.tslib,global.ng.core,global.ng.common,global.ng.elements,global.ng.platformBrowser,global.Rx.Observable,global.rxjs));
}(this, (function (exports,tslib,core,common,elements,platformBrowser,fromPromise,rxjs) { 'use strict';

    platformBrowser.ɵinitDomAdapter();
    // 定义全局对象
    ((window)).iwe7 = ((window)).iwe7 || {};
    var ElementInjector = (function () {
        function ElementInjector() {
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @return {?}
         */
        ElementInjector.prototype.get = function (token, notFoundValue) {
            switch (token) {
                case core.PLATFORM_ID:
                    return common.ɵPLATFORM_BROWSER_ID;
                case common.PlatformLocation:
                    return new platformBrowser.ɵBrowserPlatformLocation(this.get(common.DOCUMENT));
                case core.NgZone:
                    return new core.NgZone({
                        enableLongStackTrace: false
                    });
                case core.Compiler:
                    return new core.Compiler();
                case common.DOCUMENT:
                    return document;
                default:
                    return notFoundValue;
            }
        };
        return ElementInjector;
    }());
    var /** @type {?} */ elementInjector = new ElementInjector();
    /**
     * @param {?} appModule
     * @return {?}
     */
    function getJitModuleInjector(appModule) {
        var /** @type {?} */ compiler = elementInjector.get(core.Compiler);
        var /** @type {?} */ AppModuleNgFactory = compiler.compileModuleSync(appModule);
        return AppModuleNgFactory.create(elementInjector).injector;
    }
    /**
     * @param {?} ngModule
     * @param {?} parentInjector
     * @return {?}
     */
    function createJitElement(ngModule, parentInjector) {
        var /** @type {?} */ compiler = elementInjector.get(core.Compiler);
        var /** @type {?} */ moduleWithComponentFactories = compiler.compileModuleAndAllComponentsSync(ngModule);
        var /** @type {?} */ componentFactorys = moduleWithComponentFactories.componentFactories;
        var /** @type {?} */ ngModuleFactory = moduleWithComponentFactories.ngModuleFactory;
        componentFactorys.map(function (res) {
            customElements.define(res.selector, elements.createCustomElement(res.componentType, {
                injector: ngModuleFactory.create(parentInjector).injector
            }));
        });
    }
    /**
     * @param {?} appModuleFactory
     * @param {?=} moduleFactory
     * @param {?=} parentInjector
     * @return {?}
     */
    function createAotElements(appModuleFactory, moduleFactory, parentInjector) {
        // 主
        parentInjector = parentInjector || elementInjector;
        var /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
        var /** @type {?} */ moduleRef;
        var /** @type {?} */ moduleType;
        if (moduleFactory) {
            moduleRef = moduleFactory.create(appModuleRef.injector);
            moduleType = moduleFactory.moduleType;
        }
        else {
            moduleRef = appModuleRef;
            moduleType = appModuleFactory.moduleType;
        }
        // 子
        var /** @type {?} */ componentFactoryResolver = moduleRef.componentFactoryResolver;
        var /** @type {?} */ decorators = ((moduleType)).decorators;
        var /** @type {?} */ obsers = [];
        decorators.map(function (res) {
            var /** @type {?} */ args = res.args;
            args.map(function (arg) {
                var /** @type {?} */ entryComponents = arg.entryComponents;
                if (entryComponents) {
                    entryComponents.map(function (res) {
                        var /** @type {?} */ componentFactory = componentFactoryResolver.resolveComponentFactory(res);
                        customElements.define(componentFactory.selector, elements.createCustomElement(componentFactory.componentType, {
                            injector: moduleRef.injector
                        }));
                        obsers.push(fromPromise.fromPromise(customElements
                            .whenDefined(componentFactory.selector)
                            .then(function (res) {
                            return componentFactory.selector;
                        })));
                    });
                }
            });
        });
        ((window)).loadModules$ = rxjs.forkJoin.apply(void 0, tslib.__spread(obsers));
    }
    /**
     * @param {?} appModuleFactory
     * @param {?} moduleFactory
     * @param {?} componentFactory
     * @param {?=} parentInjector
     * @return {?}
     */
    function createAotElement(appModuleFactory, moduleFactory, componentFactory, parentInjector) {
        // 主
        parentInjector = parentInjector || elementInjector;
        var /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
        // 子
        var /** @type {?} */ moduleRef = moduleFactory.create(appModuleRef.injector);
        var /** @type {?} */ instance = moduleRef.instance;
        var /** @type {?} */ allComponent = instance.getElements();
        customElements.define(componentFactory.selector, elements.createCustomElement(componentFactory.componentType, {
            injector: moduleRef.injector
        }));
    }
    /**
     * @param {?} appModuleFactory
     * @param {?} moduleFactory
     * @param {?} componentFactory
     * @param {?=} parentInjector
     * @return {?}
     */
    function createComponent(appModuleFactory, moduleFactory, componentFactory, parentInjector) { }
    /**
     * @param {?} appModuleFactory
     * @param {?} moduleFactory
     * @param {?=} parentInjector
     * @return {?}
     */
    function createModule(appModuleFactory, moduleFactory, parentInjector) {
        // 主
        parentInjector = parentInjector || elementInjector;
        var /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
        var /** @type {?} */ componentFactoryResolver = appModuleRef.componentFactoryResolver;
        // 子
        var /** @type {?} */ moduleRef = moduleFactory.create(appModuleRef.injector);
        var /** @type {?} */ instance = moduleRef.instance;
        var /** @type {?} */ allComponent = instance.getElements();
        allComponent.map(function (res) { });
    }

    exports.ElementInjector = ElementInjector;
    exports.elementInjector = elementInjector;
    exports.getJitModuleInjector = getJitModuleInjector;
    exports.createJitElement = createJitElement;
    exports.createAotElements = createAotElements;
    exports.createAotElement = createAotElement;
    exports.createComponent = createComponent;
    exports.createModule = createModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=iwe7-elements.umd.js.map
