import * as tslib_1 from "tslib";
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { NgZone, PLATFORM_ID, Compiler } from "@angular/core";
import { ɵPLATFORM_BROWSER_ID as PLATFORM_BROWSER_ID } from "@angular/common";
import { DOCUMENT, PlatformLocation } from "@angular/common";
import { createCustomElement } from "@angular/elements";
import { ɵBrowserPlatformLocation as BrowserPlatformLocation, ɵinitDomAdapter as initDomAdapter } from "@angular/platform-browser";
import { fromPromise } from "rxjs/observable/fromPromise";
import { forkJoin } from "rxjs";
initDomAdapter();
// 定义全局对象
((window)).iwe7 = ((window)).iwe7 || {};
var ElementInjector = /** @class */ (function () {
    function ElementInjector() {
    }
    /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @return {?}
     */
    ElementInjector.prototype.get = function (token, notFoundValue) {
        switch (token) {
            case PLATFORM_ID:
                return PLATFORM_BROWSER_ID;
            case PlatformLocation:
                return new BrowserPlatformLocation(this.get(DOCUMENT));
            case NgZone:
                return new NgZone({
                    enableLongStackTrace: false
                });
            case Compiler:
                return new Compiler();
            case DOCUMENT:
                return document;
            default:
                return notFoundValue;
        }
    };
    return ElementInjector;
}());
export { ElementInjector };
export var /** @type {?} */ elementInjector = new ElementInjector();
/**
 * @param {?} appModule
 * @return {?}
 */
export function getJitModuleInjector(appModule) {
    var /** @type {?} */ compiler = elementInjector.get(Compiler);
    var /** @type {?} */ AppModuleNgFactory = compiler.compileModuleSync(appModule);
    return AppModuleNgFactory.create(elementInjector).injector;
}
/**
 * @param {?} ngModule
 * @param {?} parentInjector
 * @return {?}
 */
export function createJitElement(ngModule, parentInjector) {
    var /** @type {?} */ compiler = elementInjector.get(Compiler);
    var /** @type {?} */ moduleWithComponentFactories = compiler.compileModuleAndAllComponentsSync(ngModule);
    var /** @type {?} */ componentFactorys = moduleWithComponentFactories.componentFactories;
    var /** @type {?} */ ngModuleFactory = moduleWithComponentFactories.ngModuleFactory;
    componentFactorys.map(function (res) {
        customElements.define(res.selector, createCustomElement(res.componentType, {
            injector: ngModuleFactory.create(parentInjector).injector
        }));
    });
}
/**
 * @param {?} appModuleFactory
 * @param {?=} moduleFactory
 * @param {?=} parentInjector
 * @return {?}
 */
export function createAotElements(appModuleFactory, moduleFactory, parentInjector) {
    // 主
    parentInjector = parentInjector || elementInjector;
    var /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
    var /** @type {?} */ moduleRef;
    var /** @type {?} */ moduleType;
    if (moduleFactory) {
        moduleRef = moduleFactory.create(appModuleRef.injector);
        moduleType = moduleFactory.moduleType;
    }
    else {
        moduleRef = appModuleRef;
        moduleType = appModuleFactory.moduleType;
    }
    // 子
    var /** @type {?} */ componentFactoryResolver = moduleRef.componentFactoryResolver;
    var /** @type {?} */ decorators = ((moduleType)).decorators;
    var /** @type {?} */ obsers = [];
    decorators.map(function (res) {
        var /** @type {?} */ args = res.args;
        args.map(function (arg) {
            var /** @type {?} */ entryComponents = arg.entryComponents;
            if (entryComponents) {
                entryComponents.map(function (res) {
                    var /** @type {?} */ componentFactory = componentFactoryResolver.resolveComponentFactory(res);
                    customElements.define(componentFactory.selector, createCustomElement(componentFactory.componentType, {
                        injector: moduleRef.injector
                    }));
                    obsers.push(fromPromise(customElements
                        .whenDefined(componentFactory.selector)
                        .then(function (res) {
                        return componentFactory.selector;
                    })));
                });
            }
        });
    });
    ((window)).loadModules$ = forkJoin.apply(void 0, tslib_1.__spread(obsers));
}
/**
 * @param {?} appModuleFactory
 * @param {?} moduleFactory
 * @param {?} componentFactory
 * @param {?=} parentInjector
 * @return {?}
 */
export function createAotElement(appModuleFactory, moduleFactory, componentFactory, parentInjector) {
    // 主
    parentInjector = parentInjector || elementInjector;
    var /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
    // 子
    var /** @type {?} */ moduleRef = moduleFactory.create(appModuleRef.injector);
    var /** @type {?} */ instance = moduleRef.instance;
    var /** @type {?} */ allComponent = instance.getElements();
    customElements.define(componentFactory.selector, createCustomElement(componentFactory.componentType, {
        injector: moduleRef.injector
    }));
}
/**
 * @param {?} appModuleFactory
 * @param {?} moduleFactory
 * @param {?} componentFactory
 * @param {?=} parentInjector
 * @return {?}
 */
export function createComponent(appModuleFactory, moduleFactory, componentFactory, parentInjector) { }
/**
 * @param {?} appModuleFactory
 * @param {?} moduleFactory
 * @param {?=} parentInjector
 * @return {?}
 */
export function createModule(appModuleFactory, moduleFactory, parentInjector) {
    // 主
    parentInjector = parentInjector || elementInjector;
    var /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
    var /** @type {?} */ componentFactoryResolver = appModuleRef.componentFactoryResolver;
    // 子
    var /** @type {?} */ moduleRef = moduleFactory.create(appModuleRef.injector);
    var /** @type {?} */ instance = moduleRef.instance;
    var /** @type {?} */ allComponent = instance.getElements();
    var /** @type {?} */ obsers = [];
    allComponent.map(function (res) { });
}
//# sourceMappingURL=injector.js.map
