import { NgZone, PLATFORM_ID, Compiler } from '@angular/core';
import { ɵPLATFORM_BROWSER_ID, DOCUMENT, PlatformLocation } from '@angular/common';
import { createCustomElement } from '@angular/elements';
import { ɵBrowserPlatformLocation, ɵinitDomAdapter } from '@angular/platform-browser';
import { fromPromise } from 'rxjs/observable/fromPromise';
import { forkJoin } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
ɵinitDomAdapter();
// 定义全局对象
(/** @type {?} */ (window)).iwe7 = (/** @type {?} */ (window)).iwe7 || {};
class ElementInjector {
    /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @return {?}
     */
    get(token, notFoundValue) {
        switch (token) {
            case PLATFORM_ID:
                return ɵPLATFORM_BROWSER_ID;
            case PlatformLocation:
                return new ɵBrowserPlatformLocation(this.get(DOCUMENT));
            case NgZone:
                return new NgZone({
                    enableLongStackTrace: false
                });
            case Compiler:
                return new Compiler();
            case DOCUMENT:
                return document;
            default:
                return notFoundValue;
        }
    }
}
const /** @type {?} */ elementInjector = new ElementInjector();
/**
 * @param {?} appModule
 * @return {?}
 */
function getJitModuleInjector(appModule) {
    let /** @type {?} */ compiler = elementInjector.get(Compiler);
    let /** @type {?} */ AppModuleNgFactory = compiler.compileModuleSync(appModule);
    return AppModuleNgFactory.create(elementInjector).injector;
}
/**
 * @param {?} ngModule
 * @param {?} parentInjector
 * @return {?}
 */
function createJitElement(ngModule, parentInjector) {
    let /** @type {?} */ compiler = elementInjector.get(Compiler);
    let /** @type {?} */ moduleWithComponentFactories = compiler.compileModuleAndAllComponentsSync(ngModule);
    let /** @type {?} */ componentFactorys = moduleWithComponentFactories.componentFactories;
    let /** @type {?} */ ngModuleFactory = moduleWithComponentFactories.ngModuleFactory;
    componentFactorys.map((res) => {
        customElements.define(res.selector, createCustomElement(res.componentType, {
            injector: ngModuleFactory.create(parentInjector).injector
        }));
    });
}
/**
 * @param {?} appModuleFactory
 * @param {?=} moduleFactory
 * @param {?=} parentInjector
 * @return {?}
 */
function createAotElements(appModuleFactory, moduleFactory, parentInjector) {
    // 主
    parentInjector = parentInjector || elementInjector;
    let /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
    let /** @type {?} */ moduleRef;
    let /** @type {?} */ moduleType;
    if (moduleFactory) {
        moduleRef = moduleFactory.create(appModuleRef.injector);
        moduleType = moduleFactory.moduleType;
    }
    else {
        moduleRef = appModuleRef;
        moduleType = appModuleFactory.moduleType;
    }
    // 子
    let /** @type {?} */ componentFactoryResolver = moduleRef.componentFactoryResolver;
    let /** @type {?} */ decorators = (/** @type {?} */ (moduleType)).decorators;
    let /** @type {?} */ obsers = [];
    decorators.map((res) => {
        let /** @type {?} */ args = res.args;
        args.map((arg) => {
            let /** @type {?} */ entryComponents = arg.entryComponents;
            if (entryComponents) {
                entryComponents.map((res) => {
                    let /** @type {?} */ componentFactory = componentFactoryResolver.resolveComponentFactory(res);
                    customElements.define(componentFactory.selector, createCustomElement(componentFactory.componentType, {
                        injector: moduleRef.injector
                    }));
                    obsers.push(fromPromise(customElements
                        .whenDefined(componentFactory.selector)
                        .then((res) => {
                        return componentFactory.selector;
                    })));
                });
            }
        });
    });
    (/** @type {?} */ (window)).loadModules$ = forkJoin(...obsers);
}
/**
 * @param {?} appModuleFactory
 * @param {?} moduleFactory
 * @param {?} componentFactory
 * @param {?=} parentInjector
 * @return {?}
 */
function createAotElement(appModuleFactory, moduleFactory, componentFactory, parentInjector) {
    // 主
    parentInjector = parentInjector || elementInjector;
    let /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
    // 子
    let /** @type {?} */ moduleRef = moduleFactory.create(appModuleRef.injector);
    let /** @type {?} */ instance = moduleRef.instance;
    let /** @type {?} */ allComponent = instance.getElements();
    customElements.define(componentFactory.selector, createCustomElement(componentFactory.componentType, {
        injector: moduleRef.injector
    }));
}
/**
 * @param {?} appModuleFactory
 * @param {?} moduleFactory
 * @param {?} componentFactory
 * @param {?=} parentInjector
 * @return {?}
 */
function createComponent(appModuleFactory, moduleFactory, componentFactory, parentInjector) { }
/**
 * @param {?} appModuleFactory
 * @param {?} moduleFactory
 * @param {?=} parentInjector
 * @return {?}
 */
function createModule(appModuleFactory, moduleFactory, parentInjector) {
    // 主
    parentInjector = parentInjector || elementInjector;
    let /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
    let /** @type {?} */ componentFactoryResolver = appModuleRef.componentFactoryResolver;
    // 子
    let /** @type {?} */ moduleRef = moduleFactory.create(appModuleRef.injector);
    let /** @type {?} */ instance = moduleRef.instance;
    let /** @type {?} */ allComponent = instance.getElements();
    allComponent.map((res) => { });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { ElementInjector, elementInjector, getJitModuleInjector, createJitElement, createAotElements, createAotElement, createComponent, createModule };
//# sourceMappingURL=iwe7-elements.js.map
